#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>



clear_screen(clear, local) char *clear; int local;



{



        int length, n;



        length = strlen(clear);



        for (n=0; n<length; n++) {

            Bconout(local, *clear);

            *clear++;

        }



        if (local == 1)

            write_line("E", 2);



}



rev_on(revon, local) char *revon; int local;



{



        int length, n;



        length = strlen(revon);



        for (n=0; n<length; n++) {

            Bconout(local, *revon);

            *revon++;

        }



        if (local == 1)

            write_line("p", 2);



}



rev_off(revoff, local) char *revoff; int local;



{



        int length, n;



        length = strlen(revoff);



        for (n=0; n<length; n++) {

            Bconout(local, *revoff);

            *revoff++;

        }



        if (local == 1)

            write_line("q", 2);



}



get_line(s, length, local) char *s; int length, local;



{



    int slength, bell;

    time_t lastchar, secs;



    slength = 1;

    length += 2;

    bell = 0;



    time(&lastchar);



    while (slength < length) {



        if (local == 1 && cd_check() == 0)

            return(0);



        time(&secs);



        if ((secs - lastchar) > 179) {

            Bconout(local, 7);

            write_line("\r\n\r\nTimed out due to inactivity!\r\n\r\n", local);

            return(0);

        }



        if ((secs - lastchar) == 150 && !bell) {

            bell = 1;

            Bconout(local, 7);

        }



        if (Bconstat(local) == 0) {

            if (local == 1 && Bconstat(2) == -1)

                *s = Bconin(2);

            else

                continue;

        }



        else

            *s = Bconin(local); 



        bell = 0;

        time(&lastchar);



        if (*s < 32 && *s !=13 && *s !=8)

            continue;

        if (*s == '\b' || *s == 127) {

            if (slength > 1) {

                slength--;

                *s--;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                continue;

            }

            else

                continue;

        }

        if (slength == (length - 1) && *s != '\r')

            continue;

        if (local == 1)

            Bconout(2, *s);

        Bconout(local, *s);

        if (*s == '\r') {

            Bconout(local, '\n');

            if (local == 1)

                Bconout(2, '\n');

            *s = 0;

            return(1);

        }    

        slength++;

        *s++;



    }



    *s = 0;



    return(1);



}



write_line(s, local) char *s; int local;



{

    int length, slength;

    char c;



    length = strlen(s);

    slength = 0;



    while (slength < length) {

        if (local == 1 && cd_check() == 0)

            exit(0);

        if (Bconstat(local) == -1 || Bconstat(2) == -1) {

            if (local == 1 && Bconstat(2) == -1)

                c = Bconin(2);

            if (Bconstat(local) == -1)

                c = Bconin(local);

            if (c == 'q' || c == 'Q' || c == 3)

                return(0);

            if (c == 19) {

                while (Bconstat(local) == 0 && Bconstat(2) == 0) {

                    if (local == 1 && cd_check() == 0)

                        exit(0);

                }



                if (Bconstat(local) == -1)

                    c = Bconin(local);

                else

                    c = Bconin(2);



                if (c == 3 || c == 'q' || c == 'Q')

                    return(0);

            }



        }



        if (Bcostat(local) == -1) {

            Bconout(local, *s);

            if (local == 1)

                Bconout(2, *s);

            slength++;

            *s++;

        }

    }

}



char get_char(local) int local;



{



    char c;

    time_t lastchar, secs;

    int bell;



    bell = c = 0;



    time(&lastchar);



    while (c == 0) {



        if (local == 1 && cd_check() == 0)

            exit(0);



        time(&secs);



        if ((secs - lastchar) > 179) {

            Bconout(local, 7);

            write_line("\r\n\r\nTimed out due to inactivity!\r\n\r\n", local);

            exit(0);

        }



        if ((secs - lastchar) == 150 && !bell) {

            bell = 1;

            Bconout(local, 7);

        }



        if (Bconstat(local) == 0) {

            if (local == 1 && Bconstat(2) == -1)

                c = Bconin(2);

            else

                continue;

        }



        else

            c = Bconin(local); 



        bell = 0;

        time(&lastchar);



        if (c != 13 && c < 32)

            c = 0;



    }



    return(c);



}



strip_string(string) char *string;



{



    while (*string != 0) {

        if (*string == 10 || *string == 13)

            *string = 0;

        *string