#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>



extern int games;



int new = 0;



show_file(output, local)



char *output; int local;



{

    int fd, n;



    if ((fd = Fopen(output, 0)) < 0) {

        return(0);

    }



    while((n = Fread(fd, 159L, output)) > 0) {

        output[n] = 0;

        if (!write_line(output, local)) {

            Fclose(fd);

            return(2);

        }

    }



    Fclose(fd);



    return(1);



}



list_games(file, output, local, alias, clear, maxgames, nogame, history, menu, news, maxdays, revon, revoff) 



char *file, *output; int local; char *alias, *clear; int maxgames, nogame;

char *history, *menu, *news; int maxdays; char *revon, *revoff;



{



    int fd, n, c, prev, jgame, join, bp;

    char ans, opt;



    long laspos, curpos;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;



    c = -1;

    n = 1;

    join = 1;



    sprintf(output, "%stccpgame.lst", file);



    fd = Fopen(output, 2);

        

    for (;;n++) {



        if (c == 10 || c == -1) {

            laspos = Fseek(0L, fd, 1);

            prev = n;

            clear_screen(clear, local);

            if (!write_line("Game    White                              Black\r\n\r\n", local))

                return(1);

            c = 0;

        }



        Fread(fd, (long) sizeof(members), &members);



        if (join && pnmatch(members.white, alias, 0) && pnmatch(members.black, "No_Player", 0))

            join = 0;

        if (join && pnmatch(members.black, alias, 0) && pnmatch(members.white, "No_Player", 0))

            join = 0;

        if (pnmatch(members.white, "No_Player", 0))

            members.white[0] = 0;

        if (pnmatch(members.black, "No_Player", 0))

            members.black[0] = 0;

        sprintf(output, "%3d     %-30s     %-30s\r\n", n, members.white, members.black); 

        if (!write_line(output, local))

            return(1);



        c++;



        if (n == nogame || c == 10) {



            ans = 0;



            while (ans != 13) {

                curpos = Fseek(0L, fd, 1);

                write_line("\r\nJ=Join Game, V=View Game, C=Cancel Game, E=Exit, <RETURN>=Continue: ", local);

                ans = get_char(local);

                sprintf(output, "%c\r\n", ans);

                write_line(output, local);



                if (ans == 'c' || ans == 'C') {

                    write_line("\r\nCancel Game No: ", local);

                    if (!get_line(output, 3, local))

                        return(0);

                    jgame = atoi(output);

                    Fseek((68L * (long) (jgame - 1)), fd, 0);

                    Fread(fd, (long) sizeof(members), &members);

                    if (pnmatch(members.white, alias, 0) && pnmatch(members.black, "No_Player", 0) || pnmatch(members.black, alias, 0) && pnmatch(members.white, "No_Player", 0)) {

                        Fseek((68L * (long) (jgame - 1)), fd, 0);

                        sprintf(members.white, "No_Player");

                        sprintf(members.black, "No_Player");

                        Fwrite(fd, (long) sizeof(members), &members);

                        games--;

                        write_player(output, file);

                        sprintf(output, "\r\nGame %d cancelled.\r\n", jgame);

                        write_line(output, local);

                    }

                    else {

                        write_line("\r\nSorry, you may only cancel a game you began that is awaiting a second player.\r\n", local);

                    }



                    if (!show_list(fd, laspos, prev, local, output)) { 

                        Fclose(fd);

                        return(1);

                    }



                    join = 1;



                    Fseek(curpos, fd, 0);

                }



                if (ans == 'v' || ans == 'V') {

                    write_line("\r\nView Game No: ", local);

                    if (!get_line(output, 3, local))

                        return(0);

                    jgame = atoi(output);

                    Fseek((68L * (long) (jgame - 1)), fd, 0);

                    Fread(fd, (long) sizeof(members), &members);

                    if (pnmatch(members.white, "No_Player", 0) || pnmatch(members.black, "No_Player", 0)) {

                        sprintf(output, "\r\nGame %d is not a game in progress.  Please make another selection.\r\n", jgame);

                        write_line(output, local);

                        continue;

                    }

                    clear_screen(clear, local);

                    sprintf(output, "%stccpbrd.%d", file, jgame);

                    if ((bp = Fopen(output, 0)) > 0) {

                        if (!display_board(bp, output, local, jgame, revon, revoff, members.turn, members.white, members.black, alias, members.turn, maxdays))

                            write_line("\r\n", local);

                    }

                    opt = 0;



                    while(opt != 'e' && opt != 'E') {

                        write_line("\r\nRedisplay <B>oard or <return>, Show <M>oves, <E>xit: ", local);

                        opt = get_char(local);

                        if (opt == 13 || opt == 'B' || opt == 'b') {

                            clear_screen(clear, local);

                            if (bp > 0) {

                                if (!display_board(bp, output, local, jgame, revon, revoff, members.turn, members.white, members.black, alias, members.turn, maxdays))

                                    write_line("\r\n", local);

                            }

                        }

                        if (opt == 'M' || opt == 'm') {

                            clear_screen(clear, local);

                            sprintf(output, "%s.%03d", history, jgame);

                            show_file(output, local);

                        }

                    }



                    clear_screen(clear, local);

                    if (!show_list(fd, laspos, prev, local, output)) { 

                        Fclose(fd);

                        return(1);

                    }



                    Fseek(curpos, fd, 0);

                }



                if (ans == 13) {

                    continue;

                }



                if (ans == 'e' || ans == 'E') {

                    Fclose(fd);

                    return(1);

                }



                if (ans == 'j' || ans == 'J') {

                    if (!join) {

                        write_line("\r\nSorry, you can't join another game until the one you have opened is filled.\r\n", local);

                        continue;

                    }

                    if (games < maxgames) {

                        sprintf(output, "\r\nYou may join %d more games.\r\n", (maxgames - games));

                        write_line(output, local);

                        if (join_game(fd, alias, local, nogame, file, &join, history, menu, news, output, maxdays) == 2)

                            return(0);

                        write_player(output, file);                        

                        if (!show_list(fd, laspos, prev, local, output)) { 

                            Fclose(fd);

                            return(1);

                        }



                        Fseek(curpos, fd, 0);

                    }



                    else

                        write_line("\r\nSorry, but you cannot join any more games...\r\n", local);

                }



            }



            if (n == nogame) {

                c = -1;

                n = 0;

                Fseek(0L, fd, 0);

            }



        }



    }



    Fclose(fd);



    return(1);



}



join_game(fd, alias, local, nogame, file, join, history, menu, news, output, maxdays)



int fd; char *alias; int local, nogame; char *file;

int *join; char *history, *menu, *news, *output; int maxdays;



{

    char ans;

    int slot;

    int n, game, jgame;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;



    Fseek(0L, fd, 0);



    new = n = jgame = 0;



    while(Fread(fd, (long) sizeof(members), &members) > 0) {

        n++;

        if (!new && pnmatch(members.white, "No_Player", 0) && pnmatch(members.black, "No_Player", 0)) {

            new = n;

            break;

        }

    }



    if (new) {

        sprintf(output, "\r\nYou may join game %d as its first player or you may join one of the following\r\ngames currently awaiting a second player:\r\n\r\n", new);

        write_line(output, local);

    }



    else {

        write_line("\r\nThe following games are awaiting a second player:\r\n\r\n", local);

    }



    Fseek(0L, fd, 0);



    n = game = 0;



    while(Fread(fd, (long) sizeof(members), &members) > 0) {

        game++;

        if (pnmatch(members.black, "No_Player", 0) && !pnmatch(members.white, "No_Player", 0)){

            sprintf(output, "Game %d (White: %s) needs a player for black.\r\n", game, members.white);

            write_line(output, local);

            n++;

        }

        if (pnmatch(members.white, "No_Player", 0) && !pnmatch(members.black, "No_Player", 0)) {

            sprintf(output, "Game %d (Black: %s) needs a player for white.\r\n", game, members.black);

            write_line(output, local);

            n++;

        }

    }



    if (!n)

        write_line("There are no games currently awaiting a second player.\r\n", local);

    

    if (!new && !n) {

        write_line("\r\nNo openings in any game.  Try again at a later date...\r\n", local);

        return(0);

    }



    write_line("\r\nJoin Game No: ", local);

    if (!get_line(output, 3, local))

        return(2);

    jgame = atoi(output);



    if (jgame < 1 || jgame > nogame) {

        write_line("\r\nThat is not a valid game number!  Please select another game...\r\n", local);

        return(0);

    }



    Fseek((68L * (long) (jgame - 1)), fd, 0);

    Fread(fd, (long) sizeof(members), &members);



    if (pnmatch(members.white, "No_Player", 0) && pnmatch(members.black, "No_Player", 0)) {

        if (jgame > new) {

            write_line("\r\nYou may start a new game in position ", local);

            sprintf(members.white, "%d", new);

            write_line(members.white, local);

            write_line(" or join a game now awaiting a player.\r\n", local);

            return(0);

        }

    }



    if (pnmatch(members.white, alias, 0) || pnmatch(members.black, alias, 0)) {

        write_line("\r\nYou are already a player in that game!\r\n", local);

        return(0);

    }



    if (!pnmatch(members.white, "No_Player", 0) && !pnmatch(members.black, "No_Player", 0)) {

        write_line("\r\nSorry, there is no opening in that game.\r\n", local);

        return(0);

    }



    if (pnmatch(members.white, "No_Player", 0) && pnmatch(members.black, "No_Player", 0)) {

        write_line("\r\nPlay white, black or cancel? (w/b/C) ", local);

        ans = get_char(local);



        slot = -1;



        if (ans == 'b' || ans == 'B') {

            write_line("Black\r\n", local);

            slot = 0;

            *join = 0;

        }



        if (ans == 'w' || ans == 'W') {

            write_line("White\r\n", local);

            slot = 1;

            *join = 0;

        }



        if (slot == -1) {

            write_line("Cancel\r\n", local);

            return(0);

        }



    }



    if (!pnmatch(members.white, "No_Player", 0) && pnmatch(members.black, "No_Player", 0)) {

        write_line("\r\nPlay black in this game? (y/N) ", local);

        ans = get_char(local);



        if (ans  == 'y' || ans == 'Y') {

            write_line("Yes\r\n", local);

            slot = 0;

            *join = 1;

        }



        else {

            write_line("No\r\n", local);

            return(0);

        }



    }



    if (!pnmatch(members.black, "No_Player", 0) && pnmatch(members.white, "No_Player", 0)) {

        write_line("\r\nPlay white in this game? (y/N) ", local);

        ans = get_char(local);



        if (ans == 'y' || ans == 'Y') {

            write_line("Yes\r\n", local);

            slot = 1;

            *join = 1;

        }



        else {

            write_line("No\r\n", local);

            return(0);

        }



    }



    games++;



    Fseek((68L * (long) (jgame - 1)), fd, 0);



    if (slot) {

        strcpy(members.white, alias);

        Fwrite(fd, (long) sizeof(members), &members);

    }



    else {

        strcpy(members.black, alias);

        Fwrite(fd, (long) sizeof(members), &members);

    }

    

    if (!pnmatch(members.white, "No_Player", 0) && !pnmatch(members.black, "No_Player", 0)) {

        write_line("\r\nOne moment...  Setting up the game board...", local);

        initialize_game(file, jgame, history, menu, maxdays);

        sprintf(output, "Game %d:  %s and %s begin play.", jgame, members.white, members.black);

        write_news(output, news);

        write_line("Done!\r\n", local);

    }



    if (!pnmatch(members.white, "No_Player", 0) && pnmatch(members.black, "No_Player", 0) || !pnmatch(members.black, "No_Player", 0) && pnmatch(members.white, "No_Player", 0)) {

        sprintf(output, "\r\nNOTE:  This slot will be freed if no one joins your game within %d days...\r\n", (maxdays * 3));

        write_line(output, local);

        init_one_player(output, file, jgame, maxdays);

    }



}



show_list(fd, laspos, prev, local, output) 



int fd; long laspos; int prev; int local; char *output;



{





    int n;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;



    Fseek(laspos, fd, 0);



    if (!write_line("\r\nGame    White                              Black\r\n\r\n", local))

        return(0);



    for (n=prev; n<(prev + 10); n++) {

        if (Fread(fd, (long) sizeof(members), &members) < 1)

            return(1);

        if (pnmatch(members.white, "No_Player", 0))

            members.white[0] = 0;

        if (pnmatch(members.black, "No_Player", 0))

            members.black[0] = 0;

        sprintf(output, "%3d     %-30s     %-30s\r\n", n, members.white, members.black); 

        if (!write_line(output, local))

            return(0);

    }

}



init_one_player(output, file, jgame, maxdays) char *output, *file;

int jgame, maxdays;



{



    int bp;



    struct {

        char square[65];

        int move;

        time_t move_date;

        char last_move[6];

        int d_pawn_move;

        int check;

        int wpoints;

        int bpoints;

        int draw;

        int wking, bking;

        int wqrook, wkrook, bqrook, bkrook;

        int wdraw, bdraw;

        char reserved[31]; /* only for unitialized games */

    } board;



    board.square[0] =board.move_date = board.last_move[0] = 0;

    board.check = board.wpoints = board.bpoints = 0;

    board.draw = board.wking = board.bking = board.wqrook = 0;

    board.wkrook = board.bqrook = board.bkrook = board.wdraw = 0;

    board.bdraw = 0;

    board.d_pawn_move = -999; /* no double pawn move */



    strcpy(board.square, "                                                                ");

    board.move = 0;



    time(&board.move_date);



    board.move_date = board.move_date + (86400L * (long) (maxdays * 3));



    sprintf(output, "%stccpbrd.%d", file, jgame);



    Fdelete(output);



    bp = Fcreate(output, 0);



    Fwrite(bp, (long) sizeof(board), &board);



    Fclose(bp);



}



initialize_game(file, jgame, history, menu, maxdays) char *file; int jgame;

char *history, *menu; int maxdays;



{



    int bp;



    char output[90];



    struct {

        char square[65];

        int move;

        time_t move_date;

        char last_move[6];

        int d_pawn_move;

        int check;

        int wpoints;

        int bpoints;

        int draw;

        int wking, bking;

        int wqrook, wkrook, bqrook, bkrook;

        int wdraw, bdraw;

    } board;



    board.square[0] =board.move_date = board.last_move[0] = 0;

    board.check = board.wpoints = board.bpoints = 0;

    board.draw = board.wking = board.bking = board.wqrook = 0;

    board.wkrook = board.bqrook = board.bkrook = board.wdraw = 0;

    board.bdraw = 0;

    board.d_pawn_move = -999; /* no double pawn move */



    strcpy(board.square, "RNBQKBNRPPPPPPPP                                pppppppprnbqkbnr");



    board.move = 1;



    time(&board.move_date);



    board.move_date = board.move_date + (86400L * (long) maxdays);



    sprintf(output, "%stccpbrd.%d", file, jgame);



    Fdelete(output);



    bp = Fcreate(output, 0);



    Fwrite(bp, (long) sizeof(board), &board);



    Fclose(bp);



    sprintf(output, "%s.%03d", history, jgame);



    Fdelete(output);



    bp = Fcreate(output, 0);



    sprintf(output, "\r\nMove#  White                                Black\r\n");



    Fwrite(bp, (long) strlen(output), output);



    sprintf(output, "-----  -----------------------------------  -----------------------------------\r\n\r\n");



    Fwrite(bp, (long) strlen(output), output);



    Fclose(bp);



    create_menu(menu, output, file);



    sprintf(output, "wremark.%d", jgame);



    Fdelete(output);



    sprintf(output, "bremark.%d", jgame);



    Fdelete(output);



}



create_menu(menu, output, file) char *menu, *output, *file;



{



    int md, fd, n;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;

    n = 0;



    sprintf(output, "%stccpgame.lst", file);



    md = Fopen(output, 2);



    Fdelete(menu);



    fd = Fcreate(menu, 0);



    sprintf(output, "\r\n                  The Complete Chess Player Game History Menu\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "                  - - - - - - - - - - - - - - - - - - - - - -\r\n\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "Game    White                              Black\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "===============================================================================\r\n");

    Fwrite(fd, (long) strlen(output), output);



    while (Fread(md, (long) sizeof(members), &members) > 0) {

        n++;

        if (pnmatch(members.white, "No_Player", 0) || pnmatch(members.black, "No_Player", 0))

            continue;



        sprintf(output, "%3d     %-30s     %s\r\n", n, members.white, members.black);

        Fwrite(fd, (long) strlen(output), output);

    }



    sprintf(output, "===============================================================================\r\n");

    Fwrite(fd, (long) strlen(output), output);

    sprintf(output, "\r\n");

    Fwrite(fd, (long) strlen(out