#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>

#include <ctype.h>



long _stksize = 3000L;



#define VERSION "Version 1.5 registered to "



char regname[] = "_TCCP_REGISTRATION_STRING_                                  ";



struct player {

	char name[31];

	char alias[31];

	int games;

	int wins;

	int losses;

	int draws;

} plr;



long recpos;



int games;



struct pword {

   char name[31];    

} user;



int local;



char hline, vline, ltop, lbot, rtop, rbot;



main(argc, argv) int argc; char *argv[];



{



	register FILE *fp, *op;

	register int n;



	int maxgame, nogame, fd, maxdays;

	int count, status;



        int curdate, lastdate;

        time_t tnum;

        tm_t *ts;



	char buf[83], name[31], first[31], file[41], output[160], bbsname[83];

	char history[41], news[41], ans, clear[21];

	char hiscore[41], menu[41], revon[21], revoff[21];



        curdate = lastdate = 0;



	recpos = 0;



	if (argc > 1) {

		if (pnmatch(argv[1], "l", 1) || pnmatch(argv[1], "L", 1))

			local = 2;

	}



	else

		local = 1;



	if ((fp = fopen("chess.dat", "rb")) == NULL) {

		exit(1);

	}



	fgets(file, 41, fp);

	strip_string(file);

	sprintf(buf, "%sdorinfo1.def", file);

	if ((op = fopen(buf, "rb")) == NULL) {

            sprintf(bbsname, "BBS");

            fd = Fopen("forem.dat", 0);

            Fseek(3477L, fd, 0);

            Fread(fd, (long) sizeof(user), &user);

            Fclose(fd);

            for (n=strlen(user.name);n>-1;n--) {

                if (user.name[n] == ' ')

                    break;

            }



            if (n==-1) {

                sprintf(first, user.name);

                sprintf(name, user.name);

            }



            else {

                for (count=0;count<n;count++)

                    first[count] = user.name[count];

                first[count] = 0;

                sprintf(name, user.name);

            }

    

        }



        else {



            fgets(bbsname, 80, op);

            strip_string(bbsname);



            for (n=0; n<5; n++) {

	        fgets(buf, 80, op);

            }

            fgets(buf, 80, op);

            strip_string(buf);

            strcpy(first, buf);

            fgets(buf, 80, op);

            strip_string(buf);

            if (buf[0] != 0)

                sprintf(name, "%s %s", first, buf);

            else

                strcpy(name, first);

            for (n=0; n<3; n++) {

	        fgets(buf, 80, op);

            }

            fgets(buf, 80, op);

            fclose(op);

        }



	fgets(file, 41, fp);

	strip_string(file);

	fgets(buf, 5, fp);

	nogame = atoi(buf);

	fgets(buf, 5, fp);

	maxgame = atoi(buf);

	fgets(history, 41, fp);

	strip_string(history);

	fgets(buf, 5, fp);

	maxdays = atoi(buf);

	fgets(menu, 41, fp);

	strip_string(menu);

	fgets(hiscore, 41, fp);

	strip_string(hiscore);

        fgets(news, 41, fp);

        strip_string(news);



	fclose(fp);



/* Check to see if we have a registered version */



        sprintf(output, "%schessreg.dat", file);



        if ((fd = Fopen(output, 2)) < 0) {

            write_line("\r\n\r\n\aRegistration file (CHESSREG.DAT) not found!\r\n\r\n", local);

            exit(1);

        }



        count = strlen(regname);



        Fread(fd, (long) count, output);



        for(n=0;n<count;n++) {

            output[n] = ~output[n];

        }



        output[n] = 0;



        Fclose(fd);



        if (!pnmatch(regname, output, 0)) {

            exit(1);

        }



	sprintf(output, "%stccpem.lst", file);



	if ((op = fopen(output, "rb")) != NULL) {



		status = 0;



                write_line("\r\n\r\n                                KIPPER KONCEPTS\r\n\r\n", local);

                write_line("                                   Presents:\r\n\r\n", local);

                write_line("                                      THE\r\n\r\n", local);

                write_line("                             Complete Chess Player\r\n\r\n", local);

                write_line("                      Copyright 1989 by Lionel K. Gamache\r\n\r\n", local);

                write_line("                                     . . .\r\n\r\n\r\n", local);

/* Beginning of Registration notice */

                count = (int) 39 - ((strlen(VERSION) + strlen(regname)) / 2);

                for (n=0;n<count;n++)

                    output[n] = ' ';

                output[n] = 0;

                strcat(output, VERSION);

                strcat(output, regname);

                write_line(output, local);

                write_line("\r\n\r\n\r\n", local);

/* End of register section*/

                sprintf(output, "Press any key to continue, %s...", first);

                write_line(output, local);

                get_char(local);

                write_line("\r\n\r\n", local);



                if (local == 1) {



                        while(status == 0) {

                            write_line("Please select an emulation mode:\r\n\r\n", local);



                            fseek(op, 0L, 0);

                            fgets(buf, 6, op);

                            count = atoi(buf) + 1;

                            for (n=1; n<count; n++) {

                                fgets(buf, 40, op);

                                strip_string(buf);

                                sprintf(output, "%d: %s\r\n", n, buf);

                                write_line(output, local);

                                fgets(buf, 40, op);

                                fgets(buf, 40, op);

                                fgets(buf, 40, op);

                                fgets(buf, 40, op);

                            }



                            write_line("\r\nSelection (Q=Quit): ", local);

                            ans = buf[0] = get_char(local);

                            buf[1] = 0;

                            write_line(buf, local);

                            if (ans == 'q' || ans == 'Q') {

                                write_line("\r\n\r\nAborted!\r\n\r\n", local);

                                exit(0);

                            }

                            if (atoi(buf) > 0 && atoi(buf) < count)

                                status = 1;

                            else

                                write_line("\r\n\r\n", local);

                        }



                }



                else {

                    buf[0] = '1'; buf[1] = 0;

                }



	}



	if (op == NULL)

		exit(1);



	count = atoi(buf) + 1;

	fseek(op, 0L, 0);

	fgets(output, 40, op);

	for (n=1; n<count; n++) {

		fgets(output, 40, op);

		fgets(clear, 20, op);

		strip_string(clear);

		fgets(revon, 20, op);

		strip_string(revon);

		fgets(revoff, 20, op);

		strip_string(revoff);

                fgets(buf, 20, op);

                strip_string(buf);

	}



	fclose(op);



        if (buf[0] == 0) {

            sprintf(buf, "|=====");

        }



        vline = buf[0];

        hline = buf[1];

        ltop = buf[2];

        rtop = buf[3];

        lbot = buf[4];

        rbot = buf[5];



        time(&tnum);

	ts = localtime(&tnum);



        curdate = ts->tm_yday;



        sprintf(output, "%stccpdate.dat", file);



        if ((fd = Fopen(output, 2)) < 0) {

            fd = Fcreate(output, 0);

            lastdate = curdate;

            Fwrite(fd, (long) sizeof(curdate), &curdate);



        }



        else {

            Fread(fd, (long) sizeof(lastdate), &lastdate);

        }



        if (lastdate != curdate) {



            clear_screen(clear, local);



            sprintf(output, "Performing daily maintenance...  Please stand by, %s...", first);



            write_line(output, local);



            daily(file, output, history, news, hiscore, menu, local, nogame);



            Fseek(0L, fd, 0);



            Fwrite(fd, (long) sizeof(curdate), &curdate);



        }



        Fclose(fd);



        clear_screen(clear, local);



        sprintf(output, "%stccpplr.lst", file);



        if ((fd = Fopen(output, 2)) < 0) {

            fd = Fcreate(output, 0);

            initialize(file, nogame, buf, news);

        }



	recpos = status = 0;



	Fseek(0L, fd, 0);



	while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

		if (pnmatch(plr.name, name, 0)) {

			status = 1;

			break;

		}



		recpos = Fseek(0L, fd, 1);



	}



        Fclose(fd);



        if (!status) {

            sprintf(output, "You aren't in my records, %s\r\n\r\n", first);

            write_line(output, local);

            write_line("Please enter an alias to be used in future games (<CR> keeps your real name):\r\n\r\n", local);

            sprintf(plr.alias, name);

            sprintf(plr.name, name);

            plr.wins = plr.losses = plr.draws = plr.games = 0;

            if (!change_alias(file, output, local, recpos, menu, hiscore, news)) {

                sprintf(output, "%stccpplr.lst", file);

                fd = Fopen(output, 2);

                Fseek(recpos, fd, 0);

                Fwrite(fd, (long) sizeof(plr), &plr);

                Fclose(fd);

                write_scores(hiscore, output, file);

            }



            clear_screen(clear, local);

        }



        games = plr.games;



        sprintf(output, "Welcome back, %s!\r\n\r\n", plr.alias);



        write_line(output, local);



        for (;;) {



            sprintf(output, "You are currently playing in %d games.\r\n\r\n", plr.games);

            write_line(output, local);



            write_line("A - Change Your Alias\r\n", local);

            write_line("C - Continue A Game\r\n", local);

            write_line("I - TCCP Instructions\r\n", local);

            write_line("G - View/Join Game(s)\r\n", local);

            write_line("N - Display TCCP News\r\n", local);

            write_line("R - Show Player Rankings\r\n", local);

            sprintf(output, "\r\nQ - Return To %s\r\n", bbsname);

            write_line(output, local);

            write_line("\r\nSelection: ", local);



            ans = get_char(local);



            sprintf(output, "%c", ans);

            write_line(output, local);



            if (ans == 'q' || ans == 'Q')

                break;



            if (ans == 'a' || ans == 'A') {

                clear_screen(clear, local);

                change_alias(file, output, local, recpos, menu, hiscore, news);

            }



            if (ans == 'c' || ans == 'C') {

                if (!play_game(file, output, local, clear, revon, revoff, plr.alias, first, maxdays, history, hiscore, menu, news)) {

                    exit(0);

                }

            }



            if (ans == 'g' || ans == 'G') {

                if (!list_games(file, output, local, plr.alias, clear, maxgame, nogame, history, menu, news, maxdays, revon, revoff)) {

                    exit(0);

                }

            }



            if (ans == 'i' || ans == 'I') {

                clear_screen(clear, local);

                write_line("CTRL-S to pause display, CTRL-Q to continue display or CTRL-C to abort display.\r\n\r\n", local);

                sprintf(output, "%stccpgame.doc", file);

                if (show_file(output, local) == 2)

                    write_line("\r\n", local);

                write_line("\r\nPress any key to continue...", local);

                get_char(local);

            }



            if (ans == 'r' || ans == 'R') {

                clear_screen(clear, local);

                sprintf(output, hiscore);

                write_line("CTRL-S to pause display, CTRL-Q to continue display or CTRL-C to abort display.\r\n", local);

                if (show_file(output, local) == 2)

                    write_line("\r\n", local);

                write_line("\r\nPress any key to continue...", local);

                get_char(local);

            }



            

            if (ans == 'n' || ans == 'N') {

                clear_screen(clear, local);

                sprintf(output, news);

                write_line("CTRL-S to pause display, CTRL-Q to continue display or CTRL-C to abort display.\r\n", local);

                if (show_file(output, local) == 2)

                    write_line("\r\n\r\n", local);

                write_line("Press any key to continue...", local);

                get_char(local);

            }



            

            clear_screen(clear, local);



        }



        write_player(output, file);



        clear_screen(clear, local);



        sprintf(output, "Thank you for playing, %s.\r\n\r\n\r\n", first);



        write_line(output, local);

        write_line("    This program is protected under the copyright laws of the United States\r\n\r\n", local);

        write_line("           The Complete Chess Player is written by Lionel K. Gamache\r\n\r\n", local);

        write_line("                      For more information contact me at:\r\n\r\n", local);

        write_line("        Soft Asylum -*- Node 130 -*- Amarillo, Texas -*- (806) 355-9143\r\n\r\n", local);



        exit(0);



}



/* New routine include here to access global plr */



write_player(output, file) char *output, *file;



{



        int fd;



        plr.games = games;



        sprintf(output, "%stccpplr.lst", file);



        fd = Fopen(output, 2);



        Fseek(recpos, fd, 0);



        Fwrite(fd, (long) sizeof(plr), &plr);



        Fclose(fd);



}



read_player(output, file) char *output, *file;



{



        int fd;



        sprintf(output, "%stccpplr.lst", file);



        fd = Fopen(output, 2);



        Fseek(recpos, fd, 0);



        Fread(fd, (long) sizeof(plr), &plr);



        games = plr.games; /* makes sure games has new value from update */



        Fclose(fd);



}



change_alias(file, output, local, recpos, menu, hiscore, news) 



char *file, *output; int local;

long recpos;

char *menu, *hiscore, *news;



{



   /* CALIAS */



    char newalias[31], upalias[31], oldalias[31], ans;

    int n, dup, fd, bd;

    long bytesread;



    struct {

            char name[31];

	    char alias[31];

	    int games;

	    int wins;

	    int losses;

	    int draws;

    } bak;



    struct game {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    bak.name[0] = bak.alias[0] = bak.games = bak.wins = bak.losses = bak.draws = 0;

    members.white[0] = members.black[0] = members.turn[0] = 0;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    for (;;) {



        dup = 0;



        sprintf(output, "\"%s\" is your current alias.\r\n\r\n", plr.alias);

        write_line(output, local);

        write_line("Enter new alias: ", local);

        if (!get_line(newalias, 30, local))

            exit(0);



        if (pnmatch(newalias, "No_Player", 0)) {

            sprintf(output, "%s tried to change his/her alias to No_Player!  Please notify the SysOp.", plr.name);

            write_news(output, news);

            write_line("\r\n", local);

            continue;

        }



        if (newalias[0] == 0) {

            sprintf(newalias, plr.alias);

        }



        sprintf(output, "\r\n\"%s\", is this correct? (y/N) ", newalias);



        write_line(output, local);



        ans = get_char(local);



        if (ans == 'y' || ans == 'Y')

            write_line("Yes\r\n\r\n", local);

        else {

            write_line("No\r\n\r\n", local);

            continue;

        }



        sprintf(upalias, newalias);



        for(n=0; n<strlen(upalias); n++)

            upalias[n] = toupper(upalias[n]);



        sprintf(oldalias, plr.alias);



        for(n=0; n<strlen(oldalias); n++)

            oldalias[n] = toupper(oldalias[n]);



        if (pnmatch(newalias, plr.alias, 0)) {

            write_line("Alias unchanged.\r\n\r\n", local);

            Fclose(fd);

            return(0);

        }



        write_line("One moment...  Checking for duplication.\r\n\r\n", local);



        Fseek(0L, fd, 0);



	while((Fread(fd, (long) sizeof(bak), &bak)) > 0) {

            for (n=0;n<strlen(bak.alias);n++)

                bak.alias[n] = toupper(bak.alias[n]);

            if (pnmatch(oldalias, bak.alias, 0))

                continue;

            if (pnmatch(bak.alias, upalias, 0)) {

                dup = 1;

                break;

            }

        }



        if (dup) {

            write_line("That alias is already in use.\r\n\r\n", local);

            continue;

        }



        if (!dup)

            break;

    }



    write_line("Inserting new alias into data files...\r\n\r\n", local);



    sprintf(output, "%stccpgame.lst", file);



    bd = Fopen(output, 2);



    bytesread = 0;



    while(Fread(bd, (long) sizeof(members), &members) > 0) {

        if (pnmatch(members.white, plr.alias, 0)) {

            sprintf(members.white, newalias);

            Fseek(bytesread, bd, 0);

            Fwrite(bd, (long) sizeof(members), &members);

        }

        if (pnmatch(members.black, plr.alias, 0)) {

            sprintf(members.black, newalias);

            Fseek(bytesread, bd, 0);

            Fwrite(bd, (long) sizeof(members), &members);

        }

        bytesread = Fseek(0L, bd, 1);

    }



    Fclose(bd);



    Fseek(recpos, fd, 0);



    sprintf(plr.alias, newalias);



    Fwrite(fd, (long) sizeof(plr), &plr);



    Fclose(fd);



    create_menu(menu, output, file);



    write_scores(hiscore, output, file);



    write_line("New alias inserted.  Press any key to continue...", local);



    get_char(local);



    return(1);



}



write_scores(hiscore, output, file) char *hiscore, *output, *file;



{



    int fd, bd, ceiling, floor, rank, status;



    struct {

    	    char name[31];

            char alias[31];

            int games;

            int wins;

            int losses;

            int draws;

    } plr;



    plr.name[0] = plr.alias[0] = plr.games = plr.wins = plr.losses = 0;

    plr.draws = 0;



    ceiling = 32767;

    rank = 0;

    status = 1;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    Fdelete(hiscore);



    bd = Fcreate(hiscore, 0);



    sprintf(output, "\r\nRank  Name                                   Wins         Losses          Draws\r\n");



    Fwrite(bd, (long) strlen(output), output);



    sprintf(output, "===============================================================================\r\n");



    Fwrite(bd, (long) strlen(output), output);



    while(status) {



        status = 0;



        floor = -1;



        Fseek(0L, fd, 0);



	while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

            if (plr.wins < ceiling && plr.wins > floor)

                floor = plr.wins;

        }



        Fseek(0L, fd, 0);



        ceiling = floor;



        rank++;



	while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

            if (plr.wins == floor) {

                sprintf(output, "%3d   %-30s          %2d            %2d             %2d\r\n", rank, plr.alias, plr.wins, plr.losses, plr.draws);

                Fwrite(bd, (long) strlen(output), output);

                status = 1;

            }

        }

    }



    sprintf(output, "===============================================================================\r\n");



    Fwrite(bd, (long) strlen(output), output);



    Fclose(fd);

    Fclose(bd);



}



comment(output, file, jgame, alias, local, view)



char *output, *file; int jgame; char *alias; int local; char *view;



{



    FILE *fp;

    char *index();

    int wrap, tab;

    char color, c, end[3];

    long bytes, n;

    int y, z, p, print, curline, endline;

    register int x;

    char *ptr, *nptr;



    bytes = n = x = y = z = p = 0;



    end[0] = '\r'; end[1] = '\n'; end [2] = 0;



    curline = endline = 0;



    ptr = (char *) malloc(16000);

    *ptr = 0;



    if (view[0] == 'W')

        color = 'B';

    else

        color = 'W';



    write_line("                        Message Editor Command Summary:\r\n\r\n", local);

    write_line("            /A = Abort   /S = Save   /L = List   /? = Extended Help\r\n\r\n", local);

    write_line("               You MUST Prefix ALL Commands With / On A New Line\r\n\r\n", local);

    write_line("Begin edit:\r\n\r\n", local);



    sprintf(output, "%s%cremark.%d", file, color, jgame);



    if ((fp = fopen(output, "rb")) != NULL) {



        curline = 0;

        while(fgets(output, 159, fp)) {

    	    strip_string(output);

            sprintf(ptr + (curline * 80), output);

            write_line(ptr + (curline * 80), local);

            write_line("\r\n", local);

            curline++;

        }

        endline = curline;

        if (curline == 200) {

            write_line("\r\nEdit (?=Help): ", local);

        }

        fclose(fp);

    }



    output[0] = tab = c = 0;



    wrap = 1;



    for(;;) {



        if (c == 13 && curline == 200) {

            write_line("\r\nEdit (?=Help): ", local);

        }



        c = 0;



        if (local == 1 && cd_check() == 0) {

            free(ptr);

            exit(1);

        }





        if (!tab) {

            if (Bconstat(local) == 0) {

                    if (Bconstat(2) == -1 && local == 1) {

                        c = Bconin(2);

                    }

                    else

                        continue;

            }



            else {

                    c = Bconin(local); 

            }

        }



        else {

            c = ' ';

            tab--;

        }



        if (c == 9) {

            tab = 4;

            continue;

        }



        if (c == '\b' || c == 127) {

            if (z > 0) {

                output[z--] = 0;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                continue;

            }

            else

                continue;

        }



        if (c == 7) {

                Bconout(local, c);            

                continue;

            }

    

        if (c == 4) { /* Delete Word */



            z--; /* move off of null so that next routine won't be messed up */



            while (z > -1 && output[z] == ' ') {

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                z--;

            }



            while (z > -1 && output[z] != ' ') {

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                z--;

            } 



            output[++z] = 0;

            continue;



        }



        if (c == 24) {

            for(;;) {

                if (!Bcostat(local) || !Bcostat(2) && local == 1)

                    continue;

                if (!z)

                    break;

                Bconout(local, 8);

                Bconout(local, 32);

                Bconout(local, 8);

                if (local == 1) {

                    Bconout(2, 8);

                    Bconout(2, 32);

                    Bconout(2, 8);

                }

                z--;

            }

            output[z] = 0;

            continue;

        }



        if (c == 13) {



            Bconout(local, c);

            Bconout(local, 10);



            if (local == 1) {

                Bconout(2, c);

                Bconout(2, 10);

            }



            if (match(output, "/g") || match(output, "/G")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                curline = atoi(output) - 1;

                if (curline < 0)

                    curline = 0;

                if (curline > endline)

                    curline = endline;

                if (curline > 199)

                    curline = 199;

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/n") || match(output, "/N")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                x = atoi(output);

                if (x < 1)

                    x = 1;

                curline += x;

                if (curline > endline)

                    curline = endline;

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/u") || match(output, "/U")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                x = atoi(output);

                if (x < 1)

                    x = 1;

                curline -= x;

                if (curline < 0)

                    curline = 0;

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/d") || match(output, "/D")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                z = atoi(output);

                if (z < 1)

                    z = 1;

                x = curline;

                y = curline + z;

                for(;y<endline;x++,y++) {

                    sprintf(ptr+(x * 80), ptr+(y * 80));

                }

                if (y > endline) {

                    endline = curline;

                    *(ptr+(curline * 80)) = 0;

                }

                else {

                    endline -= z;

                    *(ptr+(endline * 80)) = 0;

                }

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }

                

            if (match(output, "/p") || match(output, "/P")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                y = atoi(output);

                if (y<1) {

                    x = 0;

                    y = endline;

                }

                else {

                    x = curline;

                    y += curline;

                }

                if (y<1 || y>endline)

                    y = endline;

                for(; x<y; x++) {                    

                    write_line("\r\n", local);

                    sprintf(output, "%s", (ptr + (80 * x)));

                    write_line(output, local);

                }

                write_line("\r\n", local);

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/l") || match(output, "/L")) {

                output[0] = output[2];

                output[1] = output[3];

                output[2] = output[4];

                output[3] = 0;

                y = atoi(output);

                if (y<1) {

                    x = 0;

                    y = endline;

                }

                else {

                    x = curline;

                    y += curline;

                }

                if (y<1 || y>endline)

                    y = endline;

                for(; x<y; x++) {                    

                    write_line("\r\n", local);

                    sprintf(output, "%d) %.75s", (x+1), (ptr + (80 * x)));

                    write_line(output, local);

                }

                write_line("\r\n", local);

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/c") || match(output, "/C")) {

                if (curline == endline) {

                    write_line("\r\nString not found!\r\n", local);

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline + 1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }

                    output[0] = z = 0;

                    continue;

                }

                sprintf(output, &output[3]);

                nptr = index(output, '/');

                if (!nptr) {

                    write_line("\r\nMissing parameter!\r\n", local);

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline + 1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }

                    output[0] = z = 0;

                    continue;

                }

                *nptr = 0;

                nptr++;

                sprintf(&output[80], nptr);

                nptr = ptr + (curline * 80);

                for(;;) {

                    nptr = index(nptr, output[0]);

                    if (!nptr)

                        break;

                    if (match(nptr, output))

                        break;

                    nptr++;

                }

                if (!nptr) {

                    write_line("\r\nString not found!\r\n", local);

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline + 1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }

                    output[0] = z = 0;

                    continue;

                }

                x = strlen(ptr + (curline * 80)) - strlen(nptr);

                p = strlen(output);

                y = strlen(&output[80]);

                if ((y-p) < 0) {

                    for (z=x;z<79;z++) { /* took out (79-x) */

                        *(nptr+(z-x)) = *(nptr + ((z-x) - (y-p)));

                    }

                    *(nptr + (79 - (x - (y-p)))) = 0;

                }

                else {

                    for (z=79;z>=x;z--) {

                        *(nptr + (z-x)) = *(nptr + ((z-x)-(y-p)));

                    }

                    *(nptr + (79-x)) = 0;

                }

                for (z=0;z<y;z++) {

                    if ((z+x) == 79) {

                        break;

                    }

                    *(nptr + z) = output[80 + z];

                }

                *(ptr + ((curline * 80) + 79)) = 0; 

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (pnmatch(output, "/t", 0) || pnmatch(output, "/T", 0)) {

                output[0] = z = 0;

                curline = 0;

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }

                continue;

            }



            if (pnmatch(output, "/b", 0) || pnmatch(output, "/B", 0)) {

                curline = endline;

                output[0] = z = 0;

                continue;

            }



            if (match(output, "/i", 1) || match(output, "/I", 1)) {

                if (endline > 199 || curline == endline) {

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline + 1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }

                    output[0] = z = 0;

                    continue;

                }

                x = endline;

                for (;x>=curline;x--) {

                    sprintf(ptr + ((x+1) * 80), ptr + (x * 80));

                }

                *(ptr + (curline * 80)) = 0;

                endline++;



                if (strlen(output) > 3)

                    sprintf(ptr + (curline * 80), &output[3]);



                curline++;



                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }



                output[0] = z = 0;

                continue;

            }



            if (pnmatch(output, "/j", 0) || pnmatch(output, "/J", 0)) {

                if (curline == 0) {

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline+1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }

                    output[0] = z = 0;

                    continue;

                }

                write_line("\r\n", local);

                sprintf(output, ptr + ((curline - 1) * 80));

                nptr = output;

                while (*nptr == ' ' && *nptr != 0)

                    nptr++;

                if (*nptr != 0) {

                    y = (int) 39 - (strlen(nptr) / 2);

                    sprintf(output, nptr);

                    nptr = ptr + ((curline - 1) * 80);

                    for (x=0;x<y;x++)

                        *nptr++ = ' ';

                    sprintf(nptr, output);

                }

                write_line((ptr + (80 * (curline-1))), local);

                write_line("\r\n", local);

                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline+1));

                    write_line(output, local);

                    write_line(ptr + (80 * curline), local);

                    write_line("\r\n", local);

                }

                output[0] = z = 0;

                continue;

            }



            if (pnmatch(output, "/w", 0) || pnmatch(output, "/W", 0)) {

                if (!wrap) {

                    write_line("\r\nWord wrap ON\r\n", local);

                    wrap = 1;

                }



                else {

                    write_line("\r\nWord wrap OFF\r\n", local);

                    wrap = 0;

                }



                if (curline == endline && curline < 200)

                    write_line("\r\n", local);



                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }



                output[0] = z = 0;

                continue;

            }



            if (pnmatch(output, "/a", 0) || pnmatch(output, "/A", 0)) {

                write_line("\r\nAbort? ", local);

                output[0] = get_char(local);

                if (output[0] == 'y' || output[0] == 'Y') {

                    write_line("Yes\r\n", local);

                    break;

                }

                else {

                    write_line("No\r\n", local);

                    if (curline == endline && curline < 200)

                        write_line("\r\n", local);

                    if (curline < endline) {

                        sprintf(output, "\r\n%d:\r\n", (curline + 1));

                        write_line(output, local);

                        write_line((ptr + (80 * curline)), local);

                        write_line("\r\n", local);

                    }



                    output[0] = z = 0;

                    continue;

                }

            }



            if (pnmatch(output, "/#", 0)) {

                write_line("\r\nSorry, line numbers are disabled to allow 80 column word wrap.\r\n", local);

                if (curline == endline && curline < 200)

                    write_line("\r\n", local);



                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }



                output[0] = z = 0;

                continue;

            }



            if (pnmatch(output, "/s", 0) || match(output, "/S", 0)) {

                sprintf(output, "%s%cremark.%d", file, color, jgame);

                if ((fp = fopen(output, "wb")) == NULL) {

                    write_line("\r\nWrite error!\r\n", local); 

                    break;

                }

                for (x=0;x<endline;x++) {

                    bytes += (long) strlen(ptr + (x * 80));

                    fputs(ptr + (x * 80), fp);

                    fputs("\r\n", fp);

                }

                fclose(fp);

                sprintf(output, "\r\nSaved %ld bytes.\r\n", bytes);

                write_line(output, local);

                break;

            }



            if (pnmatch(output, "/?", 0) || curline == 200 && output[0] == '?') {

                write_line("\r\n", local);

                sprintf(output, "%stccphelp.txt", file);

                x = show_file(output, local);

                if (x==0) {

                    write_line("File not found!\r\n", local);

                }

                if (x==2) {

                    write_line("\r\n", local);

                }

                if (curline == endline && curline < 200)

                    write_line("\r\n", local);



                if (curline < endline) {

                    sprintf(output, "\r\n%d:\r\n", (curline + 1));

                    write_line(output, local);

                    write_line((ptr + (80 * curline)), local);

                    write_line("\r\n", local);

                }



                output[0] = z = 0;

                continue;

            }



            if (curline < 200) {

                sprintf((ptr + (80 * curline)), output);

                curline++;

            }



            if (curline > endline)

                endline = curline;



            if (curline < endline) {

                sprintf(output, "\r\n%d:\r\n", (curline + 1));

                write_line(output, local);

                write_line((ptr + (80 * curline)), local);

                write_line("\r\n", local);

            }



            z = 0;

            output[z] = 0;



            continue;



        }



        if (c < 32 || c > 126)

            print = 0;

        else

            print = 1;



        if (print) {



            if (curline == 200 && z == 64)

                continue;



            if (z == 79) {

                if (curline < endline || curline > 198 || !wrap) {

                    continue;

                }

                if (output[0] == '/' && output[1] == 'c' || output[0] == '/' && output[1] == 'C') {

                    continue;

                }

                if (output[0] == '/' && output[1] == 'i' || output[0] == '/' && output[1] == 'I') {

                    continue;

                }

            }



            if (z == 79) {



                for (x=79;x>-1;x--) {

                    if (output[x] == ' ')

                        break;

                }



                if (output[x] == ' ') {

                    y = x;  

                    p = 0;



                    strncpy((ptr + (80 * curline)), output, x);

                    *(ptr + (curline * 80 + x)) = 0;



                    curline++;



                    if (curline > endline)

                        endline = curline;

                    

                    while(y < 80) {

                        y++;

                        output[p] = output[y];

                        p++;

                        output[p] = 0;

                    }



                    for(;x<79;++x) {

                        Bconout(local, 8);

                        Bconout(local, 32);

                        Bconout(local, 8);

                        if (local == 1) {

                            Bconout(2, 8);

                            Bconout(2, 32);

                            Bconout(2, 8);

                        }

                    }



                    y = 0;



                    Bconout(local, 13);                

                    Bconout(local, 10);

                    if (local == 1) {

                        Bconout(2, 13);

                        Bconout(2, 10);

                    }



                    while(output[y] != 0) {

                        Bconout(local, output[y]);

                        if (local == 1) 

                            Bconout(2, output[y]);

                        y++;

                    }

    

                    z = y;



                }



                else {

                    Bconout(local, 13);

                    Bconout(local, 10);

                    if (local == 1) {

                        Bconout(2, 13);

                        Bconout(2, 10);

                    }



                    sprintf((ptr + (80 * curline)), output);

                    curline++;



                    if (curline > endline)

                        endline = curline;

                    

                    z = 0;

                    output[z] = 0;

                 }



            }



            output[z++] = c;

            output[z] = 0;



            Bconout(local, c);

            if (local == 1)

                Bconout(2, c);



        }



    }



    free(ptr);



}



match(string, pattern) char *string, *pattern;



{

    int length, match, z;



    match = 1;



    length = strlen(pattern);



    for(z=0;z<length;z++) {

        if (*(string+z) == 0 || *(pattern+z) == 0) {

            match=0;

            break;

        }

        if (*(string+z) != *(pattern+z)) {

            match = 0;

            break;

        }

    }



    return(match);



}



write_news(output, news) char *output, *news;



{



    int i, n, fd, month, day, year;

    time_t tnum;

    tm_t *ts;

    char date[14];



    time(&tnum);

    ts = localtime(&tnum);



    day = ts->tm_mday;

    month = ts->tm_mon;

    year = ts->tm_year;



    fd = Fopen(news, 2);



    Fseek((Fseek(0L, fd, 2)), fd, 0);



    sprintf(date, "%d/%d/%d\r\n\r\n", (month+1), day, year);



    Fwrite(fd, (long) strlen(date), date);



    if (strlen(output) > 79) {

        n = 79;

        do {

            n--;

        } while(output[n] != ' ');

        for(i=strlen(output);i>n;i--) {

            output[i+1] = output[i];

        }

        output[n] = '\r';

        output[n+1] = '\n';

    }



    strcat(output, "\r\n\r\n");



    Fwrite(fd, (long) strlen(output), output);



    Fclose(fd);



}



int cd_check()



{



char *gpip;

long stack;

char test;



   gpip=(char *)0xFFFFFA01L;

   stack=Super(0L);

   test= *gpip;    

   Super(stack);

   if (test & 2) 

      return(0);

   else

      return(1);

}

