#include <stdio.h>

#include <osbind.h>

#include <time.h>

#include <bios.h>

#include <ctype.h>



struct {

    char square[65];

    int move;

    time_t move_date;

    char last_move[6];

    int d_pawn_move;

    int check;

    int wpoints;

    int bpoints;

    int draw;

    int wking, bking;

    int wqrook, wkrook, bqrook, bkrook;

    int wdraw, bdraw;

} back, board;



struct {

	char name[31];

	char alias[31];

	int games;

	int wins;

	int losses;

	int draws;

} plr;



struct pword {

   char name[31];    

} user;



main()



{



    int fd, bp, n, jgame, status, move, i, start, end, chckmate, gscan;

    int nogame, maxgame

    char gameno[4], view[6], option[7], ans;

    time_t curdate, timeleft;



    char buf[83], name[31], first[31], file[41], output[160];

    char history[41], news[41], ans, clear[10];

    char hiscore[41], menu[41], revon[10], revoff[10];



    struct {

        char white[31];

        char black[31];

        char turn[6];

    } members;



    members.white[0] = 0;

    members.black[0] = 0;

    members.turn[0] = 0;



	if ((fp = fopen("chess.dat", "rb")) == NULL) {

		exit(1);

	}



	fgets(file, 41, fp);



	fgets(file, 41, fp);

	strip_string(file);

	fgets(buf, 5, fp);

	nogame = atoi(buf);

	fgets(buf, 5, fp);

	maxgame = atoi(buf);

	fgets(history, 41, fp);

	strip_string(history);

	fgets(buf, 5, fp);

	maxdays = atoi(buf);

	fgets(menu, 41, fp);

	strip_string(menu);

	fgets(hiscore, 41, fp);

	strip_string(hiscore);

        fgets(news, 41, fp);

        strip_string(news);



	fclose(fp);



    for(jgame=0;jgame<maxgames;jgame++) {



        Fseek((68L * (long) (jgame - 1)), fd, 0);



        Fread(fd, (long) sizeof(members), &members);    



            if (curdate > timeleft || pnmatch(option, "Resign", 0) || board.draw == 3) {



                chckmate = checkmate(members.turn);



                if (chckmate == 2 || board.draw == 3) {

                    update_player(file, members.white, 0, 0, 1, output);

                    update_player(file, members.black, 0, 0, 1, output);

                    *draws = *draws + 1;

                }



                else {

    

                    if (members.turn[0] == 'W') {

                        update_player(file, members.white, 0, 1, 0, output);

                        update_player(file, members.black, 1, 0, 0, output);

                    }



                    if (members.turn[0] == 'B') {

                        update_player(file, members.black, 0, 1, 0, output);

                        update_player(file, members.white, 1, 0, 0, output);

                    }



                    if (members.turn[0] == view[0])

                        *losses = *losses + 1;

                    else

                        *wins = *wins + 1;

                }



                sprintf(output, "%s.%03d", history, jgame);



                Fclose(bp);



                bp = Fopen(output, 2);



                n = Fseek(0L, bp, 2);



                if (members.turn[0] == 'W') {

                    sprintf(output, "%5d", board.move);

                    Fwrite(bp, (long) strlen(output), output);

                }



                else    

                    Fseek((n-2L), bp, 0);



                sprintf(output, "  ");



                if (board.draw == 3 && !chckmate) 

                    strcat(output, "Game drawn by agreement\r\n");



                if (board.draw == 1 && !chckmate)

                    strcat(output, "Game drawn by default\r\n");



                if (chckmate == 1)

                    strcat(output, "Checkmate\r\n");



                if (chckmate == 2)

                    strcat(output, "Stalemate\r\n");



                if (option[0] == 'R' && !chckmate || curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1)

                    strcat(output, "Resigns\r\n");



                Fwrite(bp, (long) strlen(output), output);



                Fclose(bp);



                if (board.draw == 3 && !chckmate) {

                    sprintf(output, "Game %d:  %s and %s agree to a draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (board.draw == 1 && !chckmate) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s accepts by default %s's offer to draw after %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s checkmates %s in %d moves.", jgame, members.white, members.black, board.move);

                    write_news(output, news);

                }



                if (chckmate == 2) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.black, members.white, board.move);

                    else

                        sprintf(output, "Game %d:  %s stalemates %s at move %d.  Game drawn.", jgame, members.white, members.black, board.move);        

                    write_news(output, news);

                }



                if (option[0] == 'R' && !chckmate || curdate > timeleft && !chckmate && board.draw != 3 && board.draw != 1) {

                    if (members.turn[0] == 'W')

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.white, members.black, board.move);

                    else

                        sprintf(output, "Game %d:  %s resigns to %s after %d moves.", jgame, members.black, members.white, board.move);

                    write_news(output, news);

                }



                sprintf(members.white, "No_Player");

                sprintf(members.black, "No_Player");

                sprintf(members.turn, "White");



                Fseek((68L * (long) (jgame - 1)), fd, 0);



                Fwrite(fd, (long) sizeof(members), &members);    



                write_scores(hiscore, output, file);



                create_menu(menu, output, file);



                games -= 1;



                break;



        }



    }



}



update_player(file, alias, wins, losses, draws, output)



char *file, *alias; int wins, losses, draws; char *output;



{



    int fd;

    long recpos;



    struct chess {

        char name[31];

        char alias[31];

        int games;

        int wins;

        int losses;

        int draws;

    } plr;



    plr.name[0] = plr.alias[0] = plr.games = plr.wins = plr.losses = 0;

    plr.draws = 0;



    sprintf(output, "%stccpplr.lst", file);



    fd = Fopen(output, 2);



    recpos = 0;



    while((Fread(fd, (long) sizeof(plr), &plr)) > 0) {

        if (pnmatch(plr.alias, alias, 0))

            break;



        recpos = Fseek(0L, fd, 1);



    }



    plr.wins += wins;

    plr.losses += losses;

    plr.draws += draws;

    plr.games -= 1;



    Fseek(recpos, fd, 0);



    Fwrite(fd, (long) sizeof(plr), &plr);



}



checkmate(color) char *color;



{



    int i, n, end, status;

    char endsqr, piece;

    int kqmove[8] = {1, -1, 7, -7, 8, -8, 9, -9};

    int rook[4] = {1, -1, 8, -8};

    int bishop[4] = {7, -7, 9, -9};

    int knight[8] = {6, -6, 10, -10, 15, -15, 17, -17};

    int wpawn[6] = {8, 7, 9, 16};

    int bpawn[6] = {-8, -7, -9, -16};



    if (board.check)

        status = 1;

    else

        status = 2;



    for (i=0;i<64;i++) {

        piece = board.square[i];



        if (piece == ' ')

            continue;



        if (isupper(piece) && *color == 'B' || islower(piece) && *color == 'W')

            continue;



        if (piece == 'K' && *color == 'W' && i==4) {

            end = 6;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[4] = 'K';

                board.square[7] = 'R';

                board.square[5] = board.square[6] = ' ';

            }

        }



        if (piece == 'K' && *color == 'W' && i==4) {

            end = 2;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[4] = 'K';

                board.square[0] = 'R';

                board.square[2] = board.square[3] = ' ';

            }

        }



        if (piece == 'k' && *color == 'B' && i==60) {

            end = 58;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[60] = 'k';

                board.square[56] = 'r';

                board.square[58] = board.square[59] = ' ';

            }

        }



        if (piece == 'k' && *color == 'B' && i==60) {

            end = 62;

            if (check_move(i, end)) {

                if (!incheck(find_king(color)))

                    return(0);

                board.square[60] = 'k';

                board.square[63] = 'r';

                board.square[61] = board.square[62] = ' ';

            }

        }



        if (piece == 'K' && *color == 'W' || piece == 'k' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += kqmove[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    break;

                }

            }

        }



        if (piece == 'Q' && *color == 'W' || piece == 'q' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += kqmove[n];

                    endsqr = board.square[end];

                    if (!check_move(end - kqmove[n], end)) {

                        board.square[end - kqmove[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - kqmove[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - kqmove[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'R' && *color == 'W' || piece == 'r' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += rook[n];

                    endsqr = board.square[end];

                    if (!check_move(end - rook[n], end)) {

                        board.square[end - rook[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - rook[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - rook[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'B' && *color == 'W' || piece == 'b' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += bishop[n];

                    endsqr = board.square[end];

                    if (!check_move(end - bishop[n], end)) {

                        board.square[end - bishop[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[end - bishop[n]] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    if (isupper(piece) && islower(endsqr) || islower(piece) && isupper(endsqr)) {

                        board.square[end - bishop[n]] = ' ';

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                }

            }

        }



        if (piece == 'N' && *color == 'W' || piece == 'n' && *color == 'B') {

            for (n=0;n<8;n++) {

                end = i;

                for (;;) {

                    end += knight[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    break;

                }

            }

        }



        if (piece == 'P' && *color == 'W') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += wpawn[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        if (back.d_pawn_move > -1) {

                            board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                            board.d_pawn_move = back.d_pawn_move;

                        }

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    if (back.d_pawn_move > -1) {

                        board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                        board.d_pawn_move = back.d_pawn_move;

                    }

                    break;

                }

            }

        }



        if (piece == 'p' && *color == 'B') {

            for (n=0;n<4;n++) {

                end = i;

                for (;;) {

                    end += bpawn[n];

                    endsqr = board.square[end];

                    if (!check_move(i, end)) {

                        board.square[i] = piece;

                        board.square[end] = endsqr;

                        if (back.d_pawn_move > -1) {

                            board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                            board.d_pawn_move = back.d_pawn_move;

                        }

                        break;

                    }

                    board.square[i] = ' ';

                    board.square[end] = piece;

                    if (!incheck(find_king(color)))

                        return(0);

                    board.square[i] = piece;

                    board.square[end] = endsqr;

                    if (back.d_pawn_move > -1) {

                        board.square[back.d_pawn_move] = back.square[back.d_pawn_move];

                        board.d_pawn_move = back.d_pawn_move;

                    }

                    break;

                }

            }

        }

    }



    return(status);



}



write_move(history, color, gameno, start, end) char *history, *color; 

int gameno, start, end;



{



    int fd;

    char line[50], output[50];

    register long n;



    sprintf(line, "%s.%03d", history, gameno);



    if ((fd = Fopen(line, 2)) < 0)

        return(0);



    n = Fseek(0L, fd, 2);



    if (*color == 'B') {

        sprintf(line, "%5d", board.move);

        Fwrite(fd, (long) strlen(line), line);

    }



    else

        Fseek((n-2L), fd, 0);



    sprintf(line, "  ");



    Fwrite(fd, (long) strlen(line), line);



    sprintf(line, "%s", board.last_move);



    if (back.square[end] != ' ') {

            strcat(line, " (");

            if (back.square[start] == 'K' || back.square[start] == 'k')

                strcat(line, "King");

            if (back.square[start] == 'Q' || back.square[start] == 'q')

                strcat(line, "Queen");

            if (back.square[start] == 'R' || back.square[start] == 'r')

                strcat(line, "Rook");

            if (back.square[start] == 'B' || back.square[start] == 'b')

                strcat(line, "Bishop");

            if (back.square[start] == 'N' || back.square[start] == 'n')

                strcat(line, "Knight");

            if (back.square[start] == 'P' || back.square[start] == 'p')

                strcat(line, "Pawn");

            strcat(line, " x ");

            if (back.square[end] == 'K' || back.square[end] == 'k')

                strcat(line, "King");

            if (back.square[end] == 'Q' || back.square[end] == 'q')

                strcat(line, "Queen");

            if (back.square[end] == 'R' || back.square[end] == 'r')

                strcat(line, "Rook");

            if (back.square[end] == 'B' || back.square[end] == 'b')

                strcat(line, "Bishop");

            if (back.square[end] == 'N' || back.square[end] == 'n')

                strcat(line, "Knight");

            if (back.square[end] == 'P' || back.square[end] == 'p')

                strcat(line, "Pawn");

            strcat(line, ")");

    }



    if (board.d_pawn_move == -32767)

        strcat(line, " (Pawn x Pawn)");



    if (back.square[start] == 'K' && start == 4 && end == 6)

        strcat(line, " (Castles Short)");



    if (back.square[start] == 'K' && start == 4 && end == 2)

        strcat(line, " (Castles Long)");



    if (back.square[start] == 'k' && start == 60 && end == 62)

        strcat(line, " (Castles Short)");



    if (back.square[start] == 'k' && start == 60 && end == 58)

        strcat(line, " (Castles Long)");



    if (board.check)

        strcat(line, " Check!");



    sprintf(output, "%-35s\r\n", line);



    Fwrite(fd, (long) strlen(output), output);



    Fclose(fd);



}





incheck(start) int start;



{



    register int i;

    int endrow, startrow, endcol, startcol;



    for (i=start;;i--) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endcol == 0)

            break;



    }





    for (i=start;;i++) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r') 

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 1)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endcol == 7)

            break;



    }



    for (i=start;;i+=-8) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endrow == 0)

            break;



    }



    for (i=start;;i+=8) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='r')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 8)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='R')

                return(1);

            break;

        }



        if (endrow == 7)

            break;



    }



    for (i=start;;i+=7) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='p' && i == start + 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            break;

        }



        if (endcol == 0 || endrow == 7)

            break;

    }



    for (i=start;;i+=-7) {

        endrow = i / 8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='P' && i == start - 7)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 7)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            break;

        }



        if (endcol == 7 || endrow == 0)

            break;



    }



    for (i=start;;i+=9) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='p' && i == start + 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start + 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start + 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            break;

        }



        if (endcol == 7 || endrow == 7)

            break;



    }



    for (i=start;;i+=-9) {

        endrow = i/8;

        endcol = i - (endrow * 8);



        if (board.square[i] != ' ' && i != start) {

            if (board.square[start]=='k' && board.square[i]=='Q')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='B')

                return(1);

            if (board.square[start]=='k' && board.square[i]=='P' && i == start - 9)

                return(1);

            if (board.square[start]=='k' && board.square[i]=='K' && i == start - 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='k' && i == start - 9)

                return(1);

            if (board.square[start]=='K' && board.square[i]=='q')

                return(1);

            if (board.square[start]=='K' && board.square[i]=='b')

                return(1);

            break;

        }



        if (endcol == 0 || endrow == 0)

            break;



    }



    startrow = start / 8;

    startcol = start - (startrow * 8);



    i = start - 17;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 15;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 17;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 15;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 10;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start + 6;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i < 64 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 6;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol > startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    i = start - 10;

    endrow = i/8;

    endcol = i - (endrow * 8);



    if (i > -1 && endcol < startcol) {

        if (board.square[i]=='n' && board.square[start]=='K' || board.square[i]=='N' && board.square[start]=='k')

            return(1);

    }



    return(0);



}



check_move(start, end)



int start, end;



{



    int srow, erow, scol, ecol;



    srow = start / 8;

    erow = end / 8;

    scol = start - (srow * 8);

    ecol = end - (erow * 8);



    if (start==end)

        return(0);



    if (start == 4 && end == 6 && board.square[4] == 'K') {

        if (board.wking == 1 || board.wkrook == 1)

            return(0);

        if (board.square[5] != ' ' || board.square[6] != ' ' || board.square[7] != 'R')

            return(0);

        board.square[4] = ' ';

        board.square[5] = 'K';

        if (incheck(5)) {

            board.square[4] = 'K';

            board.square[5] = ' ';

            return(0);

        }

        board.square[5] = ' ';

        board.square[6] = 'K';

        if (incheck(6)) {

            board.square[4] = 'K';

            board.square[6] = ' ';

            return(0);

        }

        board.square[4] = 'K';

        board.square[6] = ' ';

        board.square[7] = ' ';

        board.square[5] = 'R';

        board.wking = 1;

        board.wkrook = 1;



        return(1);

    }



    if (start == 4 && end == 2 && board.square[4] == 'K') {

        if (board.wking == 1 || board.wqrook == 1)

            return(0);

        if (board.square[1] != ' ' || board.square[2] != ' ' || board.square[3] != ' ' || board.square[0] != 'R')

            return(0);

        board.square[4] = ' ';

        board.square[3] = 'K';

        if (incheck(3)) {

            board.square[4] = 'K';

            board.square[3] = ' ';

            return(0);

        }

        board.square[3] = ' ';

        board.square[2] = 'K';

        if (incheck(2)) {

            board.square[4] = 'K';

            board.square[2] = ' ';

            return(0);

        }

        board.square[4] = 'K';

        board.square[2] = ' ';

        board.square[0] = ' ';

        board.square[3] = 'R';

        board.wking = 1;

        board.wqrook = 1;



        return(1);

    }



    if (start == 60 && end == 58 && board.square[60] == 'k') {

        if (board.bking == 1 || board.bqrook == 1)

            return(0);

        if (board.square[57] != ' ' || board.square[58] != ' ' || board.square[59] != ' ' || board.square[56] != 'r')

            return(0);

        board.square[60] = ' ';

        board.square[59] = 'k';

        if (incheck(59)) {

            board.square[60] = 'k';

            board.square[59] = ' ';

            return(0);

        }

        board.square[59] = ' ';

        board.square[58] = 'k';

        if (incheck(58)) {

            board.square[60] = 'k';

            board.square[59] = ' ';

            return(0);

        }

        board.square[60] = 'k';

        board.square[58] = ' ';

        board.square[56] = ' ';

        board.square[59] = 'r';

        board.bking = 1;

        board.bqrook = 1;



        return(1);

    }



    if (start == 60 && end == 62 && board.square[60] == 'k') {

        if (board.bking == 1 || board.bkrook == 1)

            return(0);

        if (board.square[61] != ' ' || board.square[62] != ' ' || board.square[63] != 'r')

            return(0);

        board.square[60] = ' ';

        board.square[61] = 'k';

        if (incheck(61)) {

            board.square[60] = 'k';

            board.square[61] = ' ';

            return(0);

        }

        board.square[61] = ' ';

        board.square[62] = 'k';

        if (incheck(62)) {

            board.square[60] = 'k';

            board.square[62] = ' ';

            return(0);

        }

        board.square[60] = 'k';

        board.square[62] = ' ';

        board.square[63] = ' ';

        board.square[61] = 'r';

        board.bking = 1;

        board.bkrook = 1;



        return(1);



    }



    if (board.square[start] == 'Q' || board.square[start] == 'q')

        return(queen_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'R' || board.square[start] == 'r')

        return(rook_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'B' || board.square[start] == 'b')

        return(bishop_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'K' || board.square[start] == 'k')

        return(king_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'N' || board.square[start] == 'n')

        return(knight_move(board.square, start, end, srow, erow, scol, ecol));



    if (board.square[start] == 'P' || board.square[start] == 'p')

        return(pawn_move(board.square, start, end, srow, erow, scol, ecol));

}



pawn_move(square, start, end, srow, erow, scol, ecol)



char *square; int start, end, srow, erow, scol, ecol;



{



    int add, pdouble, i, enpass;



    enpass = add = 0;

    pdouble = -999;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol && board.square[end] == ' ')

        add = 8;



    if (islower(square[start]) && erow==srow-1 && ecol==scol && board.square[end] == ' ')

        add = -8;



    if (isupper(square[start]) && start > 7 && start < 16 && erow==srow+2 && board.square[end] == ' ') {

        add = 8;

        pdouble = end;

    }



    if (islower(square[start]) && start >47 && start < 56 && erow==srow-2 && board.square[end] == ' ') {

        add = -8;

        pdouble = end;

    }



    if (isupper(square[start]) && erow==srow+1 && ecol==scol+1 && islower(square[end]))

        add = 9;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol-1 && islower(square[end]))

        add = 7;



    if (islower(square[start]) && erow==srow-1 && ecol==scol+1 && isupper(square[end]))

        add = -7;



    if (islower(square[start]) && erow==srow-1 && ecol==scol-1 && isupper(square[end]))

        add = -9;



    if (isupper(square[start]) && erow==srow+1 && ecol==scol+1 && board.d_pawn_move + 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = 9;

    }



    if (isupper(square[start]) && erow==srow+1 && ecol==scol-1 && board.d_pawn_move + 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = 7;

    }



    if (islower(square[start]) && erow==srow-1 && ecol==scol+1 && board.d_pawn_move - 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = -7;

    }



    if (islower(square[start]) && erow==srow-1 && ecol==scol-1 && board.d_pawn_move - 8 == end && board.square[end] == ' ') {

        enpass = 1;

        add = -9;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    board.d_pawn_move = pdouble;



    if (enpass) {

        board.square[board.d_pawn_move] = ' ';

        board.d_pawn_move = -32767; /* indicates en passant capture */

    }



    return(1);



}



king_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add;



    add = 0;



    if (erow==srow && ecol==scol+1)

        add = 1;



    if (erow==srow && ecol==scol-1)

        add = -1;



    if (erow==srow+1 && ecol==scol)

        add = 8;



    if (erow==srow-1 && ecol==scol)

        add = -8;



    if (erow==srow+1 && ecol==scol+1)

        add = 9;



    if (erow==srow+1 && ecol==scol-1)

        add = 7;



    if (erow==srow-1 && ecol==scol+1)

        add = -7;



    if (erow==srow-1 && ecol==scol-1)

        add = -9;



    if (!add)

        return(0);



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



knight_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add;



    add = 0;



    if (erow==srow+2 && ecol==scol+1)

        add = 17;



    if (erow==srow+2 && ecol==scol-1)

        add = 15;



    if (erow==srow-2 && ecol==scol+1)

        add = -15;



    if (erow==srow-2 && ecol==scol-1)

        add = -17;



    if (erow==srow+1 && ecol==scol+2)

        add = 10;



    if (erow==srow+1 && ecol==scol-2)

        add = 6;



    if (erow==srow-1 && ecol==scol+2)

        add = -6;



    if (erow==srow-1 && ecol==scol-2)

        add = -10;



    if (!add)

        return(0);



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);

}



bishop_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow>srow && ecol==(scol+(erow-srow))) {

        add = 9;

    }



    if (erow<srow && ecol==(scol-(srow-erow))) {

        add = -9;

    }



    if (erow>srow && ecol==(scol-(erow-srow))) {

        add = 7;

    }



    if (erow<srow && ecol==(scol+(srow-erow))) {

        add = -7;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



rook_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow==srow && ecol>scol) {

        add = 1;

    }



    if (erow==srow && ecol<scol) {

        add = -1;

    }



    if (ecol==scol && erow>srow) {

        add = 8;

    }



    if (ecol==scol && erow<srow) {

        add = -8;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



queen_move(square, start, end, srow, erow, scol, ecol) char *square; int start, end, srow, erow, scol, ecol;



{



    int add, i;



    add = 0;



    if (erow==srow && ecol>scol) {

        add = 1;

    }



    if (erow==srow && ecol<scol) {

        add = -1;

    }



    if (ecol==scol && erow>srow) {

        add = 8;

    }



    if (ecol==scol && erow<srow) {

        add = -8;

    }



    if (erow>srow && ecol==(scol+(erow-srow))) {

        add = 9;

    }



    if (erow<srow && ecol==(scol-(srow-erow))) {

        add = -9;

    }



    if (erow>srow && ecol==(scol-(erow-srow))) {

        add = 7;

    }



    if (erow<srow && ecol==(scol+(srow-erow))) {

        add = -7;

    }



    if (!add)

        return(0);



    for (i=start;;) {



        i += add;



        if (i == end)

            break;



        if (square[i] != ' ')

            return(0);

    }



    if (isupper(square[start]) && isupper(square[end]))

        return(0);

    if (islower(square[start]) && islower(square[end]))

        return(0);



    return(1);



}



convert_coord(column, row) char column, row;



{



    int coord;



    if (column < 65 || column > 72)

        return(-1);



    if (row < 49 || row > 56)

        return(-1);



    coord = (column - 65) + ((row - 49) * 8);



    if (coord < 0 || coord > 63)

        return(-1);



    return(coord);



}



check_piece(start, color) int start, *color;



{



    if (pnmatch(color, "White", 0)) {

        if (board.square[start] > 65 && board.square[start] < 83)

            return(1);

    }



    else {

        if (board.square[start] > 97 && board.square[start] < 115)

            return(1);

    }



    return(0);



}



save_board(bp) int bp;



{



    Fseek(0L, bp, 0);



    Fwrite(bp, (long) sizeof(board), &board);



}

